--[[
	State base class. All other states should inherit from this.
]]

Player = class();

function Player:constructor()
	self.Name = "playername"
	self.Gold = 0
	self.HP = 1000
	self.MaxHP = 1000
	self.Anderment = 100
	self.XP = 1
	self.Rage = 100
	self.lvl = 1
	self.X = 0
	self.Y = 0
	self.Dir1 = 0
	self.Dir2 = 0
end

function Player:update()
	local playerbase = memoryReadUIntPtr(getProc(),__GAMEBASE + addresses.base, addresses.playerbase)
	if playerbase then
		self.Name = memoryReadRepeat("string",getProc(),playerbase + addresses.playername) or "playername"
		self.Gold = memoryReadRepeat("uint",getProc(),playerbase + addresses.playergold) or 0
		self.Anderment = memoryReadRepeat("uint",getProc(),playerbase + addresses.playerardament) or 100
		self.XP = memoryReadRepeat("uint",getProc(),playerbase + addresses.playerxp) or 1
		self.lvl = memoryReadRepeat("uint",getProc(),playerbase + addresses.playerlvl) or 1
	end

	local base2 = memoryReadUIntPtr(getProc(),__GAMEBASE + addresses.base, addresses.coordsbase)
	if base2 then
		self.Rage = memoryReadRepeat("uint",getProc(),base2 + addresses.Rage) or 100	
		self.HP = memoryReadRepeat("uint",getProc(),base2 + addresses.HP) or 1000
		self.MaxHP = memoryReadRepeat("uint",getProc(),base2 + addresses.MaxHP) or 1000
		self.X = memoryReadRepeat("float",getProc(),base2 + addresses.X) or 0
		self.Y = memoryReadRepeat("float",getProc(),base2 + addresses.Y) or 0
		self.Dir1 = memoryReadRepeat("float",getProc(),base2 + addresses.dir1) or 0
		self.Dir2 = memoryReadRepeat("float",getProc(),base2 + addresses.dir2) or 0
	end
end